
. /etc/DISTRO_SPECS

KERNELVERSION='3.2.29' 

TODAYDATE="`date +%Y%m%d`"

CURDIR="`pwd`"
if [ "$CURDIR" != "/usr/src" ];then
 echo 'This script must be in /usr/src'
 exit
fi
if [ ! -d 3rd-party/filesystem ];then
 echo 'Please download the aufs2-standalone*.tar.gz to 3rd-party/filesystem'
 echo 'and all of the other 3rd-party drivers, in correct subdirectories.'
 exit
fi
if [ ! -d 3rd-party/modems ];then
 echo 'Please download the drivers in 3rd-party/modems.'
 exit
fi
if [ ! -d 3rd-party/wireless ];then
 echo 'Please download the drivers in 3rd-party/wireless'
 exit
fi
if [ ! -f DOTconfig ];then
 echo 'Please download DOTconfig, the kernel configuration file'
 echo 'If you have another file that you want to use, rename it to DOTconfig'
 exit
fi

echo
echo "This script requires that you be running a full installation of Puppy."
if [ -f /boot/vmlinuz ];then
 echo -n "This does appear to be the case, so just press ENTER to continue: "
 read YESGO
else
 echo "It seems that you are not, so aborting."
 exit
fi

echo
echo "This script is hardcoded to compile kernel ${KERNELVER3}.x"
echo "To change that, edit variable KERNELVERSION in script."
echo "(the 'x' is the kernel minor version, chosen below)"
echo

#compile kernel
echo
echo -n 'ENTER to compile kernel: '
read goforit
cd linux-${KERNELVERSION}
make -j4 clean
make -j4 mrproper
cp -f ../DOTconfig .config
make -j4 menuconfig
echo -n 'ENTER to compile kernel: '
read goforit
make -j4
sync

#place to send everything...
rm -rf /usr/src/out-k${KERNELVERSION}${POSTVER} 2> /dev/null
mkdir /usr/src/out-k${KERNELVERSION}${POSTVER}


#install kernel
echo
echo -n "ENTER to install kernel: "
read goforit
echo
echo "Installing modules..."
rm -rf /lib/modules/${KERNELVERSION} 2> /dev/null
rm -rf /lib/firmware-OLD 2> /dev/null
mv -f /lib/firmware /lib/firmware-OLD
make -j4 modules_install
sync
echo "Creating 'firmware' tarball in /usr/src/out-k${KERNELVERSION}${POSTVER}..."
cp -a -f /lib/firmware ../out-k${KERNELVERSION}${POSTVER}/
echo "Creating headers tarball in /usr/src/out-k${KERNELVERSION}${POSTVER}..."
make -j4 headers_install
sync
mkdir -p /usr/src/out-k${KERNELVERSION}${POSTVER}/linux_headers-${KERNELVERSION}${POSTVER}/usr/include
cp -a -f usr/include/* ../out-k${KERNELVERSION}${POSTVER}/linux_headers-${KERNELVERSION}${POSTVER}/usr/include/
sync

#120325 turn headers into a pet...
#linux_headers_DEV-2.6.32-40|linux_headers_DEV|2.6.32-40||BuildingBlock|4236K||linux_headers_DEV-2.6.32-40.pet||header files for 2.6.32.40 kernel||||
HDRSIZE=$(du -s -k ../out-k${KERNELVERSION}${POSTVER}/linux_headers-${KERNELVERSION}${POSTVER} | cut -f 1)
echo "linux_headers-${KERNELVERSION}${POSTVER}|linux_headers|${KERNELVERSION}${POSTVER}||BuildingBlock|${HDRSIZE}K||linux_headers-${KERNELVERSION}${POSTVER}.pet||header files for ${KERNELVERSION}${POSTVER} kernel||||" > ../out-k${KERNELVERSION}${POSTVER}/linux_headers-${KERNELVERSION}${POSTVER}/pet.specs


echo "Creating tarball of modules..."
cp -a -f /lib/modules/${KERNELVERSION} ../out-k${KERNELVERSION}${POSTVER}/

echo "Copying DOTconfig-${KERNELVERSION}${POSTVER}, System.map, vmlinuz..."
cp -f DOTconfig-${KERNELVERSION}${POSTVER} ../out-k${KERNELVERSION}${POSTVER}/
cp -f System.map ../out-k${KERNELVERSION}${POSTVER}/
cp -f modules.order ../out-k${KERNELVERSION}${POSTVER}/
cp -f modules.builtin ../out-k${KERNELVERSION}${POSTVER}/ 2>/dev/null #<=2.6.32 does not have this.
cp -f arch/x86/boot/bzImage ../out-k${KERNELVERSION}${POSTVER}/vmlinuz
sync
cd ../out-k${KERNELVERSION}${POSTVER}
dir2tgz firmware/
dir2tgz linux_headers-${KERNELVERSION}${POSTVER}
sync
tgz2pet linux_headers-${KERNELVERSION}${POSTVER}.tar.gz
dir2tgz ${KERNELVERSION}
sync
rm -rf firmware
rm -rf linux_headers-${KERNELVERSION}${POSTVER}
rm -rf ${KERNELVERSION}
cd ..
cp -f -a patches out-k${KERNELVERSION}${POSTVER}/
cp -f -a 3rd-party out-k${KERNELVERSION}${POSTVER}/
mv -f DOTconfig DOTconfig-PREVIOUS
cp -f -a DOTconfig-${KERNELVERSION}${POSTVER} DOTconfig
sync

mv -f linux-${KERNELVERSION}${POSTVER}-src-patched.tar.bz2 out-k${KERNELVERSION}${POSTVER}/
sync

echo
echo "Finished!"
echo "The next step is to run '2modules.sh' to compile 3rd-party modules."
echo "However, Puppy should be running and this will require a reboot."
echo "Just press ENTER to copy 'vmlinuz' to /boot"
echo "This script will then exit, and you will have to reboot."
echo -n "Press ENTER: "
read YESGO
if [ "$YESGO" = "" ];then
 OLDKER="`uname -r`"
 mv -f /boot/vmlinuz /boot/vmlinuz-${OLDKER}-OLD
 cp -f out-k${KERNELVERSION}${POSTVER}/vmlinuz /boot/
 echo "Copied 'vmlinuz' to /boot, now you must reboot."
fi

echo "1kernel.sh finished"
###END###
